/*
 * (C) Copyright 2008-2015 Fuzhou Rockchip Electronics Co., Ltd
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */
#include "sdmmc_config.h"
#include "../config.h"

#ifdef DRIVERS_SDMMC

/****************************************************************
* :SDPAM_FlushCache
* :cache
* ˵:adr           Ҫʼַ
*          size          ҪĴСλֽ
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
void SDPAM_FlushCache(void *adr, uint32 size)
{
#if (EN_SD_DMA || EN_SDC_INTERAL_DMA)
	CacheFlushDRegion((uint32)(unsigned long)adr, (uint32)size);
#endif
}

/****************************************************************
* :SDPAM_CleanCache
* :cache
* ˵:adr           Ҫʼַ
*          size          ҪĴСλֽ
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
void SDPAM_CleanCache(void *adr, uint32 size)
{

}


void SDPAM_InvalidateCache(void *adr, uint32 size)
{
#if (EN_SD_DMA || EN_SDC_INTERAL_DMA)
	CacheInvalidateDRegion((uint32)(unsigned long)adr, (uint32)size);
#endif
}

/****************************************************************
* :SDPAM_GetAHBFreq
* :õǰAHBƵ
* ˵:
* ֵ:صǰAHBƵʣλKHz
* ȫֱ:
* ע:
****************************************************************/
uint32 SDPAM_GetAHBFreq(SDMMC_PORT_E nSDCPort)
{
	return GetMmcCLK(nSDCPort);
}

/****************************************************************
* :SDPAM_SDCClkEnable
* :ѡǷSDMMCĹʱ
* ˵:nSDCPort      ˿ں
*          enable        Ƿʹ
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
void SDPAM_SDCClkEnable(SDMMC_PORT_E nSDCPort, uint32 enable)
{

}

/****************************************************************
* :SDPAM_SDCReset
* :SCUϸλSDMMC
* ˵:nSDCPort      ˿ں
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
void SDPAM_SDCReset(SDMMC_PORT_E nSDCPort)
{
	if (nSDCPort == SDC0)
		SDCReset(0);
	else if (nSDCPort == SDC1)
		SDCReset(1);
	else
		SDCReset(2);
}

/****************************************************************
* :SDPAM_SetMmcClkDiv
* :SCUmmc_clk_divķƵֵ
* ˵:nSDCPort      ˿ں
*          div           Ƶֵ
* ֵ:صǰAHBƵʣλKHz
* ȫֱ:
* ע:
****************************************************************/
void SDPAM_SetMmcClkDiv(SDMMC_PORT_E nSDCPort, uint32 div)
{
	if (nSDCPort == SDC0)
		SCUSelSDClk(0, div);
	else if (nSDCPort == SDC1)
		SCUSelSDClk(1, div);
	else
		SCUSelSDClk(2, div);
}

/****************************************************************
* :SDPAM_SetTuning
* :tuningֵ
* ˵:
*
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
int32 SDPAM_SetTuning(SDMMC_PORT_E nSDCPort, uint32 degree, uint32 DelayNum)
{
	if (nSDCPort == SDC0)
		return SDM_PARAM_ERROR;
	else if (nSDCPort == SDC1)
		return SDM_PARAM_ERROR;
	else
		return SCUSetTuning(2, degree, DelayNum);
}


/****************************************************************
* :SDPAM_SetMmcClkDiv
* :SCUmmc_clk_divķƵֵ
* ˵:nSDCPort      ˿ں
*          div           Ƶֵ
* ֵ:صǰAHBƵʣλKHz
* ȫֱ:
* ע:
****************************************************************/
int32  SDPAM_SetSrcFreq(SDMMC_PORT_E nSDCPort, uint32 freqKHz)
{
	if (nSDCPort == SDC0)
		return SCUSetSDClkFreq(0, freqKHz * 1000) / 1000;
	else if (nSDCPort == SDC1)
		return SCUSetSDClkFreq(1, freqKHz * 1000) / 1000;
	else
		return SCUSetSDClkFreq(2, freqKHz * 1000) / 1000;
}

#if EN_SD_DMA
/****************************************************************
* :SDPAM_DMAStart
* :һDMA
* ˵:nSDCPort      ҪݴĶ˿ں
*          dstAddr       Ŀַ
*          srcAddr       Դַ
*          size          ݳȣλֽ
*          rw            ʾҪӿд1:д0:ӿ
*          cb_f          DMAĻص
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
bool SDPAM_DMAStart(SDMMC_PORT_E nSDCPort, uint32 dstAddr, uint32 srcAddr, uint32 size, bool rw, pFunc cb_f)
{
	uint32 dmac_chn = 0;
	uint32 src_addr, dst_addr;
	uint32 mode;
	int ret = 0;

	debug("dstAddr = 0x%x, srcAddr = 0x%x, size = 0x%x, rw = %d\n", dstAddr, srcAddr, size, rw);

	if (nSDCPort == SDC0)
		dmac_chn = DMACH_SDMMC;
	else if (nSDCPort == SDC1)
		dmac_chn = DMACH_SDIO;
	else
		dmac_chn = DMACH_EMMC;

	if (rw) {
		mode = RK_DMASRC_MEM;
		src_addr = dstAddr;
		dst_addr = srcAddr;
	} else {
		mode = RK_DMASRC_HW;
		src_addr = srcAddr;
		dst_addr = dstAddr;
	}

	if (rk_dma_set_buffdone_fn(dmac_chn, (rk_dma_cbfn_t)cb_f) < 0) {
		PRINT_E("dma ch = %d set buffdone fail!\n", dmac_chn);
		return FALSE;
	}
	rk_dma_devconfig(dmac_chn, mode, src_addr);
	rk_dma_enqueue(dmac_chn, NULL, dst_addr, size << 2);
	ret = rk_dma_ctrl(dmac_chn, RK_DMAOP_START);
	if (ret < 0)
		return FALSE;

	return TRUE;
}

/****************************************************************
* :SDPAM_DMAStop
* :ֹͣһѾùDMA
* ˵:nSDCPort      ҪֹͣĶ˿ں
*          rw            ʾֹͣҪӿĲдĲ1:д0:ӿ
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
bool SDPAM_DMAStop(SDMMC_PORT_E nSDCPort, bool rw)
{
	uint32 dmac_chn = 0;
	int ret;

	if (nSDCPort == SDC0)
		dmac_chn = DMACH_SDMMC;
	else if (nSDCPort == SDC1)
		dmac_chn = DMACH_SDIO;
	else
		dmac_chn = DMACH_EMMC;

	ret = rk_dma_ctrl(dmac_chn, RK_DMAOP_STOP);
	if (ret < 0)
		return FALSE;

	rk_dma_ctrl(dmac_chn, RK_DMAOP_FLUSH);

	return TRUE;
}


static struct rk_dma_client rk_dma_sd_client = {
	.name = "rk-dma-sd",
};
static struct rk_dma_client rk_dma_sdio_client = {
	.name = "rk-dma-sdio",
};
static struct rk_dma_client rk_dma_emmc_client = {
	.name = "rk-dma-emmc",
};

bool SDPAM_DMAInit(SDMMC_PORT_E nSDCPort)
{
	struct rk_dma_client *dma_client = NULL;
	uint32 dmac_chn = 0;

	if (nSDCPort == SDC0) {
		dma_client = &rk_dma_sd_client;
		dmac_chn = DMACH_SDMMC;
	} else if (nSDCPort == SDC1) {
		dma_client = &rk_dma_sdio_client;
		dmac_chn = DMACH_SDIO;
	} else {
		dma_client = &rk_dma_emmc_client;
		dmac_chn = DMACH_EMMC;
	}

	if (rk_dma_request(dmac_chn, dma_client, NULL) < 0) {
		PRINT_E("Dmac request ch = %d fail!\n", dmac_chn);
		return FALSE;
	}

	if (rk_dma_config(dmac_chn, 4, 16) < 0) {
		PRINT_E("Dmac ch = %d config fail!\n", dmac_chn);
		return FALSE;
	}

	return TRUE;
}

bool SDPAM_DMADeInit(SDMMC_PORT_E nSDCPort)
{
	struct rk_dma_client *dma_client = NULL;
	uint32 dmac_chn = 0;

	if (nSDCPort == SDC0) {
		dma_client = &rk_dma_sd_client;
		dmac_chn = DMACH_SDMMC;
	} else if (nSDCPort == SDC1) {
		dma_client = &rk_dma_sdio_client;
		dmac_chn = DMACH_SDIO;
	} else {
		dma_client = &rk_dma_emmc_client;
		dmac_chn = DMACH_EMMC;
	}

	if (rk_dma_free(dmac_chn, dma_client) < 0) {
		PRINT_E("Dmac free ch = %d fail!\n", dmac_chn);
		return FALSE;
	}

	return TRUE;
}
#endif /* EN_SD_DMA */

/****************************************************************
* :SDPAM_INTCRegISR
* :жϿעĳ˿ڵжϷ߳
* ˵:nSDCPort      ҪעĶ˿ں
*          Routine       ߳
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
uint32 SDPAM_INTCRegISR(SDMMC_PORT_E nSDCPort, pFunc Routine)
{
	if (nSDCPort == SDC0)
		irq_install_handler(RKPLAT_IRQ_SDMMC, (interrupt_handler_t *)Routine, NULL);
	else if (nSDCPort == SDC1)
		irq_install_handler(RKPLAT_IRQ_SDIO, (interrupt_handler_t *)Routine, NULL);
	else
		irq_install_handler(RKPLAT_IRQ_EMMC, (interrupt_handler_t *)Routine, NULL);

	return TRUE;
}

/****************************************************************
* :SDPAM_INTCEnableIRQ
* :ʹжϿĳ˿ڵж
* ˵:nSDCPort      ҪʹܵĶ˿ں
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
uint32 SDPAM_INTCEnableIRQ(SDMMC_PORT_E nSDCPort)
{
	uint32 ret = 0;
	if (nSDCPort == SDC0)
		ret = irq_handler_enable(RKPLAT_IRQ_SDMMC);
	else if (nSDCPort == SDC1)
		ret = irq_handler_enable(RKPLAT_IRQ_SDIO);
	else
		ret = irq_handler_enable(RKPLAT_IRQ_EMMC);

	if (ret == 0)
		return TRUE;

	return FALSE;
}

/****************************************************************
* :SDPAM_IOMUX_SetSDPort
* :IOõĳ˿ڣҸö˿ڵ߿widthָ
* ˵:nSDCPort      ˿ں
*          width         ߿
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
uint32 SDPAM_IOMUX_SetSDPort(SDMMC_PORT_E nSDCPort, HOST_BUS_WIDTH_E width)
{
	return TRUE;
}


/****************************************************************
* :SDPAM_ControlPower
* :ָ˿ڵcardԴر
* ˵:nSDCPort    ˿ں
*          enable      1:Դ0:رյԴ
* ֵ:
* ȫֱ:
* ע:
****************************************************************/
void SDPAM_ControlPower(SDMMC_PORT_E nSDCPort, uint32 enable)
{

}

#endif /* end of #ifdef DRIVERS_SDMMC */
